﻿using Luxand;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace Face_Recognition.Pages
{
    public class MatchTemplatesModel : PageModel
    {
        [BindProperty]
        public IFormFile FirstTemplateFile { get; set; }

        [BindProperty]
        public IFormFile SecondTemplateFile { get; set; }

        public IActionResult OnPost()
        {
            if (FirstTemplateFile?.Length != FSDK.TemplateSize ||
                SecondTemplateFile?.Length != FSDK.TemplateSize)
            {
                return Redirect("MatchResult?Similarity=-1");
            }
            var template1 = new byte[FSDK.TemplateSize];
            var template2 = new byte[FSDK.TemplateSize];
            FirstTemplateFile.OpenReadStream().Read(template1, 0, FSDK.TemplateSize);
            SecondTemplateFile.OpenReadStream().Read(template2, 0, FSDK.TemplateSize);
            float similarity = 0;
            FSDK.MatchFaces(ref template1, ref template2, ref similarity);
            return Redirect($"MatchResult?Similarity={similarity}");
        }
    }
}